/**

  The Initial Developer of the Original Code is
  Matthieu  - http://www.programmation-facile.com/
  Portions created by the Initial Developer are Copyright (C) 2013
  the Initial Developer. All Rights Reserved.

  Contributor(s) :

 */


Main();


/**
 * Fonction principale
 * Appelée au chargement de la page
 * 
 */
function Main()
{
    console.log("Main");

    // création du module AngularJS         
    var oModule = angular.module("AppliAngularJS", []);

    // déclaration des contrôleurs
    oModule.controller("MainControler", MainControler) 
      .controller("ViewControler", ViewControler);
    
    // module d'affichage des icones des clients
    oModule.filter("oClientStatutIcon", function() 
    {
        return function(sState, sIconType) 
        { 
            // icone par défaut si non défini
            if(angular.isUndefined(sIconType)) 
                sIconType = "128"; 
               
            switch (sState) 
            { 
                case "connected-web": 
                    return "./images/connected-web-" + sIconType + ".png"; 

                case "connected-mobile": 
                    return "./images/connected-mobile-" + sIconType + ".png"; 

                case "disconnected": 
                    return "./images/disconnected-" + sIconType + ".png"; 

                default: 
                    return "./images/default-" + sIconType + ".png"; 
              } 
          }; 
      });

    // module de trie des clients
    oModule.filter("orderClients", function() 
    { 
        return function(array) 
        { 
            return array.sort(dynamicSort("statut"));
        }; 
    });
}


/**
 * Permet d'effectuer un trie sur une propriété d'un objet 
 * 
 * @param  {[type]} property [description]
 * @return {[type]}          [description]
 */
function dynamicSort(property)
{
  var sortOrder = 1;

  if(property[0] === "-") 
  {
      sortOrder = -1;
      property = property.substr(1);
  }

  return function (a,b) {
      var result = (a[property] < b[property]) ? -1 : (a[property] > b[property]) ? 1 : 0;
      return result * sortOrder;
  }
}



/**
 * Déclaration des variables des vues
 * 
 * @param {[type]} $scope [description]
 */
function ViewControler($scope) 
{ 
    $scope.pageTitle = "Utilisation d'AngularJS"; 
} 
     

/**
 * Déclaration des variables nécessaires dans la zone gérée par AngularJS
 * 
 * @param {[type]} $scope [description]
 */
function MainControler($scope) 
{
 /**
     * init de l'état du modèle
     * ajout du modèle et des fonctions à la vue via l’objet $scope 
     * gestion des changements du modèle
     * 
     */

    // récupère la configuration dans le local storage HTML5 
    /*
    $scope.config = localStorage.getconfig("start") || [];
      
    $scope.addConfig = function(oValue) { ... } 
    $scope.removeConfig = function(oValue) { ... } 
    $scope.doneConfig = function(oValue) { ... } 
    */

    // représentation du modèle - les données
    $scope.screenSize = "48";// taille de l'image à afficher
    $scope.clients = [
        {
          icon: "connected-mobile",
          statut: "connected",
          lastname: "DevFacile",
          firstname: "Matthieu"
        },
        {
          icon: "disconnected",
          statut: "disconnected",
          lastname: "Zuryo",
          firstname: "Yannick"
        },
        {
          icon: "indetermine",
          statut: "indetermine",
          lastname: "Barry",
          firstname: "Adeline"
        },
        {
          icon: "connected-web",
          statut: "connected",
          lastname: "Labio",
          firstname: "Antoine"
        },
        {
          icon: "disconnected",
          statut: "disconnected",
          lastname: "Plisse",
          firstname: "Didier"
        },
        {
          icon: "indetermine",
          statut: "indetermine",
          lastname: "Lirio",
          firstname: "Léa"
        },
    ]; 

    $scope.title = "Application Développement Facile"; 
} 
 
